////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 1.8
//  \   \         Application : Virtex-6 FPGA GTX Transceiver Wizard 
//  /   /         Filename : dmb_rcv_125gbps_top.v
// /___/   /\     Timestamp : 
// \   \  /  \ 
//  \___\/\___\ 
//
//
// Module DMB_RCV_125GBPS_TOP
// Generated by Xilinx Virtex-6 FPGA GTX Transceiver Wizard
// 
// 
// (c) Copyright 2009-2010 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES. 


`timescale 1ns / 1ps
`define DLY #1


//***********************************Entity Declaration************************

module DMB_RCV_125GBPS_TOP #
(
    parameter EXAMPLE_CONFIG_INDEPENDENT_LANES          =   1,   //configuration for frame gen and check
    parameter EXAMPLE_LANE_WITH_START_CHAR              =   0,    // specifies lane with unique start frame char
    parameter EXAMPLE_WORDS_IN_BRAM                     =   512,  // specifies amount of data in BRAM
    parameter EXAMPLE_SIM_GTXRESET_SPEEDUP              =   0,    // simulation setting for GTX SecureIP model
    parameter EXAMPLE_USE_CHIPSCOPE                     =   1,    // Set to 1 to use Chipscope to drive resets
    parameter ALIGNER_WAIT                              =   8'd32 // To set the wait cycles in aligner
)
(
    input wire  Q3_CLK0_MGTREFCLK_PAD_N_IN,
    input wire  Q3_CLK0_MGTREFCLK_PAD_P_IN,
    input wire  GTXTXRESET_IN,
    input wire  GTXRXRESET_IN,
    output wire TRACK_DATA_OUT,
    input  wire         RXN_IN,
    input  wire         RXP_IN,
    output wire         TXN_OUT,
    output wire         TXP_OUT
);


//************************** Register Declarations ****************************

    reg     [84:0]  ila_in_r;

// * max_fanout = 1 *
    reg             gtx0_rxresetdone_i_r;
    reg             gtx0_rxresetdone_r;
    reg             gtx0_rxresetdone_r2;
    reg             gtx0_rxresetdone_r3;
    reg     [7:0]   gtx0_rxdata_r;
    //------------------------ MGT Wrapper Wires ------------------------------
    //________________________________________________________________________
    //________________________________________________________________________
    //GTX0   (X0Y12)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [1:0]   gtx0_rxpowerdown_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire            gtx0_rxchariscomma_i;
    wire            gtx0_rxcharisk_i;
    wire            gtx0_rxdisperr_i;
    wire            gtx0_rxnotintable_i;
    wire            gtx0_rxrundisp_i;
    //----------------- Receive Ports - Clock Correction Ports -----------------
    wire    [2:0]   gtx0_rxclkcorcnt_i;
    //------------- Receive Ports - Comma Detection and Alignment --------------
    wire            gtx0_rxenmcommaalign_i;
    wire            gtx0_rxenpcommaalign_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [7:0]   gtx0_rxdata_i;
    wire            gtx0_rxrecclk_i;
    wire            gtx0_rxreset_i;
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    wire            gtx0_rxelecidle_i;
    //------ Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    wire            gtx0_rxbufreset_i;
    wire    [2:0]   gtx0_rxbufstatus_i;
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    wire            gtx0_gtxrxreset_i;
    wire            gtx0_pllrxreset_i;
    wire            gtx0_rxplllkdet_i;
    wire            gtx0_rxresetdone_i;




    //----------------------------- Global Signals -----------------------------
    wire            gtx0_tx_system_reset_c;
    wire            gtx0_rx_system_reset_c;
    wire            tied_to_ground_i;
    wire    [63:0]  tied_to_ground_vec_i;
    wire            tied_to_vcc_i;
    wire    [7:0]   tied_to_vcc_vec_i;
    wire            drp_clk_in_i;

    //--------------------------- User Clocks ---------------------------------
    wire            gtx0_rxusrclk2_i;


    //--------------------------- Reference Clocks ----------------------------
    
    wire            q3_clk0_refclk_i;
    //--------------------- Frame check/gen Module Signals --------------------
    wire            gtx0_matchn_i;
    
    wire    [2:0]   gtx0_txcharisk_float_i;
    
    wire    [31:0]  gtx0_txdata_float_i;
    
    
    wire            gtx0_block_sync_i;
    wire            gtx0_track_data_i;
    wire    [7:0]   gtx0_error_count_i;
    wire            gtx0_frame_check_reset_i;
    wire            gtx0_inc_in_i;
    wire            gtx0_inc_out_i;
    wire    [7:0]   gtx0_unscrambled_data_i;

    wire            reset_on_data_error_i;
    wire            track_data_out_i;


    //--------------------- Chipscope Signals ---------------------------------

    wire    [35:0]  tx_data_vio_control_i;
    wire    [35:0]  rx_data_vio_control_i;
    wire    [35:0]  shared_vio_control_i;
    wire    [35:0]  ila_control_i;
    wire    [31:0]  tx_data_vio_async_in_i;
    wire    [31:0]  tx_data_vio_sync_in_i;
    wire    [31:0]  tx_data_vio_async_out_i;
    wire    [31:0]  tx_data_vio_sync_out_i;
    wire    [31:0]  rx_data_vio_async_in_i;
    wire    [31:0]  rx_data_vio_sync_in_i;
    wire    [31:0]  rx_data_vio_async_out_i;
    wire    [31:0]  rx_data_vio_sync_out_i;
    wire    [31:0]  shared_vio_in_i;
    wire    [31:0]  shared_vio_out_i;
    wire    [84:0]  ila_in_i;

    wire    [31:0]  gtx0_tx_data_vio_async_in_i;
    wire    [31:0]  gtx0_tx_data_vio_sync_in_i;
    wire    [31:0]  gtx0_tx_data_vio_async_out_i;
    wire    [31:0]  gtx0_tx_data_vio_sync_out_i;
    wire    [31:0]  gtx0_rx_data_vio_async_in_i;
    wire    [31:0]  gtx0_rx_data_vio_sync_in_i;
    wire    [31:0]  gtx0_rx_data_vio_async_out_i;
    wire    [31:0]  gtx0_rx_data_vio_sync_out_i;
    wire    [84:0]  gtx0_ila_in_i;


    wire            gtxtxreset_i;
    wire            gtxrxreset_i;

    wire            user_tx_reset_i;
    wire            user_rx_reset_i;
    wire            tx_vio_clk_i;
    wire            tx_vio_clk_mux_out_i;    
    wire            rx_vio_ila_clk_i;
    wire            rx_vio_ila_clk_mux_out_i;

//**************************** Main Body of Code *******************************

    //  Static signal Assigments    
    assign tied_to_ground_i             = 1'b0;
    assign tied_to_ground_vec_i         = 64'h0000000000000000;
    assign tied_to_vcc_i                = 1'b1;
    assign tied_to_vcc_vec_i            = 8'hff;



    //---------------------Dedicated GTX Reference Clock Inputs ---------------
    // The dedicated reference clock inputs you selected in the GUI are implemented using
    // IBUFDS_GTXE1 instances.
    //
    // In the UCF file for this example design, you will see that each of
    // these IBUFDS_GTXE1 instances has been LOCed to a particular set of pins. By LOCing to these
    // locations, we tell the tools to use the dedicated input buffers to the GTX reference
    // clock network, rather than general purpose IOs. To select other pins, consult the 
    // Implementation chapter of UG___, or rerun the wizard.
    //
    // This network is the highest performace (lowest jitter) option for providing clocks
    // to the GTX transceivers.
    
    IBUFDS_GTXE1 q3_clk0_refclk_ibufds_i
    (
        .O                              (q3_clk0_refclk_i),
        .ODIV2                          (),
        .CEB                            (tied_to_ground_i),
        .I                              (Q3_CLK0_MGTREFCLK_PAD_P_IN),
        .IB                             (Q3_CLK0_MGTREFCLK_PAD_N_IN)
    );

 
    




    //--------------------------------- User Clocks ---------------------------
    
    // The clock resources in this section were added based on userclk source selections on
    // the Latency, Buffering, and Clocking page of the GUI. A few notes about user clocks:
    // * The userclk and userclk2 for each GTX datapath (TX and RX) must be phase aligned to 
    //   avoid data errors in the fabric interface whenever the datapath is wider than 10 bits
    // * To minimize clock resources, you can share clocks between GTXs. GTXs using the same frequency
    //   or multiples of the same frequency can be accomadated using MMCMs. Use caution when
    //   using RXRECCLK as a clock source, however - these clocks can typically only be shared if all
    //   the channels using the clock are receiving data from TX channels that share a reference clock 
    //   source with each other.

    BUFG rxrecclk_bufg0_i
    (
        .I                              (gtx0_rxrecclk_i),
        .O                              (gtx0_rxusrclk2_i)
    );






    //--------------------------- The GTX Wrapper -----------------------------
    
    // Use the instantiation template in the example directory to add the GTX wrapper to your design.
    // In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    // checker. The GTXs will reset, then attempt to align and transmit data. If channel bonding is 
    // enabled, bonding should occur after alignment.
    
    DMB_RCV_125GBPS #
    (
        .WRAPPER_SIM_GTXRESET_SPEEDUP   (EXAMPLE_SIM_GTXRESET_SPEEDUP)
    )
    dmb_rcv_125gbps_i
    (
 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //GTX0  (X0Y12)
        //---------------------- Loopback and Powerdown Ports ----------------------
        .GTX0_RXPOWERDOWN_IN            (gtx0_rxpowerdown_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .GTX0_RXCHARISCOMMA_OUT         (gtx0_rxchariscomma_i),
        .GTX0_RXCHARISK_OUT             (gtx0_rxcharisk_i),
        .GTX0_RXDISPERR_OUT             (gtx0_rxdisperr_i),
        .GTX0_RXNOTINTABLE_OUT          (gtx0_rxnotintable_i),
        .GTX0_RXRUNDISP_OUT             (gtx0_rxrundisp_i),
        //----------------- Receive Ports - Clock Correction Ports -----------------
        .GTX0_RXCLKCORCNT_OUT           (gtx0_rxclkcorcnt_i),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .GTX0_RXENMCOMMAALIGN_IN        (gtx0_rxenmcommaalign_i),
        .GTX0_RXENPCOMMAALIGN_IN        (gtx0_rxenpcommaalign_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTX0_RXDATA_OUT                (gtx0_rxdata_i),
        .GTX0_RXRECCLK_OUT              (gtx0_rxrecclk_i),
        .GTX0_RXRESET_IN                (!gtx0_rxplllkdet_i),
        .GTX0_RXUSRCLK2_IN              (gtx0_rxusrclk2_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTX0_RXELECIDLE_OUT            (gtx0_rxelecidle_i),
        .GTX0_RXN_IN                    (RXN_IN),
        .GTX0_RXP_IN                    (RXP_IN),
        //------ Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        .GTX0_RXBUFRESET_IN             (gtx0_rxbufreset_i),
        .GTX0_RXBUFSTATUS_OUT           (gtx0_rxbufstatus_i),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .GTX0_GTXRXRESET_IN             (gtx0_gtxrxreset_i),
        .GTX0_MGTREFCLKRX_IN            (q3_clk0_refclk_i),
        .GTX0_PLLRXRESET_IN             (gtx0_pllrxreset_i),
        .GTX0_RXPLLLKDET_OUT            (gtx0_rxplllkdet_i),
        .GTX0_RXRESETDONE_OUT           (gtx0_rxresetdone_i),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTX0_TXN_OUT                   (TXN_OUT),
        .GTX0_TXP_OUT                   (TXP_OUT)


    );



    //------------------------ User Module Resets -----------------------------
    // All the User Modules i.e. FRAME_GEN, FRAME_CHECK and the sync modules
    // are held in reset till the RESETDONE goes high. 
    // The RESETDONE is registered a couple of times on *USRCLK2 and connected 
    // to the reset of the modules
    

    always @(posedge gtx0_rxusrclk2_i)
            gtx0_rxresetdone_i_r   <=   `DLY gtx0_rxresetdone_i;

    always @(posedge gtx0_rxusrclk2_i or negedge gtx0_rxresetdone_i_r)

    begin
        if (!gtx0_rxresetdone_i_r)
        begin
            gtx0_rxresetdone_r      <=   `DLY 1'b0;
            gtx0_rxresetdone_r2     <=   `DLY 1'b0;
        end
        else
        begin
            gtx0_rxresetdone_r      <=   `DLY gtx0_rxresetdone_i_r;
            gtx0_rxresetdone_r2     <=   `DLY gtx0_rxresetdone_r;
        end
    end

    always @(posedge gtx0_rxusrclk2_i)
            gtx0_rxresetdone_r3   <=   `DLY gtx0_rxresetdone_r2;
    




    //-------------------------------- Frame Checkers -------------------------
    // The example design uses Block RAM based frame checkers to verify incoming  
    // data. By default the frame generators are loaded with a data sequence that 
    // matches the outgoing sequence of the frame generators for the TX ports.
    
    // You can modify the expected data sequence by changing the INIT values of the frame
    // checkers in this file. Pay careful attention to bit order and the spacing
    // of your control and alignment characters.
    
    // When the frame checker receives data, it attempts to synchronise to the 
    // incoming pattern by looking for the first sequence in the pattern. Once it 
    // finds the first sequence, it increments through the sequence, and indicates an 
    // error whenever the next value received does not match the expected value.


    assign gtx0_frame_check_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:gtx0_matchn_i;

    // gtx0_frame_check0 is always connected to the lane with the start of char
    // and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    assign gtx0_inc_in_i = 1'b0;

    always @(posedge gtx0_rxusrclk2_i)
         gtx0_rxdata_r <= `DLY gtx0_rxdata_i;

 
 
    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(8),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(1),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h0000000600000005000000040000000300000002000000bc0000000100000000),
        .MEM_01(256'h0000000e0000000d0000000c0000000b0000000a000000090000000800000007),
        .MEM_02(256'h000000160000001500000014000000130000001200000011000000100000000f),
        .MEM_03(256'h0000001e0000001d0000001c0000001b0000001a000000190000001800000017),
        .MEM_04(256'h000000260000002500000024000000230000002200000021000000200000001f),
        .MEM_05(256'h0000002e0000002d0000002c0000002b0000002a000000290000002800000027),
        .MEM_06(256'h000000360000003500000034000000330000003200000031000000300000002f),
        .MEM_07(256'h0000003e0000003d0000003c0000003b0000003a000000390000003800000037),
        .MEM_08(256'h000000460000004500000044000000430000004200000041000000400000003f),
        .MEM_09(256'h0000004e0000004d0000004c0000004b0000004a000000490000004800000047),
        .MEM_0A(256'h000000560000005500000054000000530000005200000051000000500000004f),
        .MEM_0B(256'h0000005e0000005d0000005c0000005b0000005a000000590000005800000057),
        .MEM_0C(256'h000000660000006500000064000000630000006200000061000000600000005f),
        .MEM_0D(256'h0000006e0000006d0000006c0000006b0000006a000000690000006800000067),
        .MEM_0E(256'h000000760000007500000074000000730000007200000071000000700000006f),
        .MEM_0F(256'h0000007e0000007d0000007c0000007b0000007a000000790000007800000077),
        .MEM_10(256'h0000000600000005000000040000000300000002000000bc0000000100000000),
        .MEM_11(256'h0000000e0000000d0000000c0000000b0000000a000000090000000800000007),
        .MEM_12(256'h000000160000001500000014000000130000001200000011000000100000000f),
        .MEM_13(256'h0000001e0000001d0000001c0000001b0000001a000000190000001800000017),
        .MEM_14(256'h000000260000002500000024000000230000002200000021000000200000001f),
        .MEM_15(256'h0000002e0000002d0000002c0000002b0000002a000000290000002800000027),
        .MEM_16(256'h000000360000003500000034000000330000003200000031000000300000002f),
        .MEM_17(256'h0000003e0000003d0000003c0000003b0000003a000000390000003800000037),
        .MEM_18(256'h000000460000004500000044000000430000004200000041000000400000003f),
        .MEM_19(256'h0000004e0000004d0000004c0000004b0000004a000000490000004800000047),
        .MEM_1A(256'h000000560000005500000054000000530000005200000051000000500000004f),
        .MEM_1B(256'h0000005e0000005d0000005c0000005b0000005a000000590000005800000057),
        .MEM_1C(256'h000000660000006500000064000000630000006200000061000000600000005f),
        .MEM_1D(256'h0000006e0000006d0000006c0000006b0000006a000000690000006800000067),
        .MEM_1E(256'h000000760000007500000074000000730000007200000071000000700000006f),
        .MEM_1F(256'h0000007e0000007d0000007c0000007b0000007a000000790000007800000077),
        .MEM_20(256'h0000000600000005000000040000000300000002000000bc0000000100000000),
        .MEM_21(256'h0000000e0000000d0000000c0000000b0000000a000000090000000800000007),
        .MEM_22(256'h000000160000001500000014000000130000001200000011000000100000000f),
        .MEM_23(256'h0000001e0000001d0000001c0000001b0000001a000000190000001800000017),
        .MEM_24(256'h000000260000002500000024000000230000002200000021000000200000001f),
        .MEM_25(256'h0000002e0000002d0000002c0000002b0000002a000000290000002800000027),
        .MEM_26(256'h000000360000003500000034000000330000003200000031000000300000002f),
        .MEM_27(256'h0000003e0000003d0000003c0000003b0000003a000000390000003800000037),
        .MEM_28(256'h000000460000004500000044000000430000004200000041000000400000003f),
        .MEM_29(256'h0000004e0000004d0000004c0000004b0000004a000000490000004800000047),
        .MEM_2A(256'h000000560000005500000054000000530000005200000051000000500000004f),
        .MEM_2B(256'h0000005e0000005d0000005c0000005b0000005a000000590000005800000057),
        .MEM_2C(256'h000000660000006500000064000000630000006200000061000000600000005f),
        .MEM_2D(256'h0000006e0000006d0000006c0000006b0000006a000000690000006800000067),
        .MEM_2E(256'h000000760000007500000074000000730000007200000071000000700000006f),
        .MEM_2F(256'h0000007e0000007d0000007c0000007b0000007a000000790000007800000077),
        .MEM_30(256'h0000000600000005000000040000000300000002000000bc0000000100000000),
        .MEM_31(256'h0000000e0000000d0000000c0000000b0000000a000000090000000800000007),
        .MEM_32(256'h000000160000001500000014000000130000001200000011000000100000000f),
        .MEM_33(256'h0000001e0000001d0000001c0000001b0000001a000000190000001800000017),
        .MEM_34(256'h000000260000002500000024000000230000002200000021000000200000001f),
        .MEM_35(256'h0000002e0000002d0000002c0000002b0000002a000000290000002800000027),
        .MEM_36(256'h000000360000003500000034000000330000003200000031000000300000002f),
        .MEM_37(256'h0000003e0000003d0000003c0000003b0000003a000000390000003800000037),
        .MEM_38(256'h000000460000004500000044000000430000004200000041000000400000003f),
        .MEM_39(256'h0000004e0000004d0000004c0000004b0000004a000000490000004800000047),
        .MEM_3A(256'h000000560000005500000054000000530000005200000051000000500000004f),
        .MEM_3B(256'h0000005e0000005d0000005c0000005b0000005a000000590000005800000057),
        .MEM_3C(256'h000000660000006500000064000000630000006200000061000000600000005f),
        .MEM_3D(256'h0000006e0000006d0000006c0000006b0000006a000000690000006800000067),
        .MEM_3E(256'h000000760000007500000074000000730000007200000071000000700000006f),
        .MEM_3F(256'h0000007e0000007d0000007c0000007b0000007a000000790000007800000077),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000100),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000000),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000100),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000000),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000100),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000000),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000100),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000000)
    )
    gtx0_frame_check
    (
        // MGT Interface
        .RX_DATA                        (gtx0_rxdata_r),
        .RX_ENMCOMMA_ALIGN              (gtx0_rxenmcommaalign_i),
        .RX_ENPCOMMA_ALIGN              (gtx0_rxenpcommaalign_i),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),
        // Control Interface
        .INC_IN                         (gtx0_inc_in_i),
        .INC_OUT                        (gtx0_inc_out_i),
        .PATTERN_MATCH_N                (gtx0_matchn_i),
        .RESET_ON_ERROR                 (gtx0_frame_check_reset_i),
        // System Interface
        .USER_CLK                       (gtx0_rxusrclk2_i),
        .SYSTEM_RESET                   (gtx0_rx_system_reset_c),
        .ERROR_COUNT                    (gtx0_error_count_i),
        .TRACK_DATA                     (gtx0_track_data_i)

    );

    



    assign TRACK_DATA_OUT = track_data_out_i;

    assign track_data_out_i = 
                                gtx0_track_data_i ;





    //--------------------------- Chipscope Connections -----------------------
    // When the example design is run in hardware, it uses chipscope to allow the
    // example design and GTX wrapper to be controlled and monitored. The 
    // EXAMPLE_USE_CHIPSCOPE parameter allows chipscope to be removed for simulation.
    
generate
if (EXAMPLE_USE_CHIPSCOPE==1) 
begin : chipscope

    // Shared VIO for all GTXs
    data_vio shared_vio_i
    (
      .control                          (shared_vio_control_i),
      .async_in                         (shared_vio_in_i),
      .async_out                        (shared_vio_out_i),
      .sync_in                          (tied_to_ground_vec_i[31:0]),
      .sync_out                         (),
      .clk                              (tied_to_ground_i)
    );

    // ICON for all VIOs
    icon i_icon
    (
      .control0                         (shared_vio_control_i),
      .control1                         (tx_data_vio_control_i),
      .control2                         (rx_data_vio_control_i),
      .control3                         (ila_control_i)
    );


    // TX VIO
    data_vio tx_data_vio_i
    (
      .control                          (tx_data_vio_control_i),
      .async_in                         (tx_data_vio_async_in_i),
      .async_out                        (tx_data_vio_async_out_i),
      .sync_in                          (tx_data_vio_sync_in_i),
      .sync_out                         (tx_data_vio_sync_out_i),
      .clk                              (gtx0_rxusrclk2_i)
    );
    
    // RX VIO
    data_vio rx_data_vio_i
    (
      .control                          (rx_data_vio_control_i),
      .async_in                         (rx_data_vio_async_in_i),
      .async_out                        (rx_data_vio_async_out_i),
      .sync_in                          (rx_data_vio_sync_in_i),
      .sync_out                         (rx_data_vio_sync_out_i),
      .clk                              (gtx0_rxusrclk2_i)
    );
    
    // RX ILA
    ila ila_i
    (
      .control                          (ila_control_i),
      .clk                              (gtx0_rxusrclk2_i),
      .trig0                            (ila_in_i)
    );




    // assign resets for frame_gen modules

    // assign resets for frame_check modules
    assign  gtx0_rx_system_reset_c = !gtx0_rxresetdone_r3 || user_rx_reset_i;

    assign  gtx0_gtxrxreset_i = gtxrxreset_i;

    // Shared VIO Outputs
    assign  gtxrxreset_i                         =  shared_vio_out_i[31];
    assign  user_tx_reset_i                      =  shared_vio_out_i[30];
    assign  user_rx_reset_i                      =  shared_vio_out_i[29];

    // Shared VIO Inputs
    assign  shared_vio_in_i[31:0]                =  32'b00000000000000000000000000000000;

    // Chipscope connections on GTX 0
    assign  gtx0_tx_data_vio_async_in_i[31:0]    =  32'b00000000000000000000000000000000;
    assign  gtx0_tx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx0_rx_data_vio_async_in_i[31]      =  gtx0_rxplllkdet_i;
    assign  gtx0_rx_data_vio_async_in_i[30]      =  gtx0_rxresetdone_i;
    assign  gtx0_rx_data_vio_async_in_i[29:0]    =  30'b000000000000000000000000000000;
    assign  gtx0_rx_data_vio_sync_in_i[31:0]     =  32'b00000000000000000000000000000000;
    assign  gtx0_pllrxreset_i                    =  rx_data_vio_async_out_i[31];
    assign  gtx0_rxpowerdown_i                   =  rx_data_vio_async_out_i[30:29];
    assign  gtx0_rxbufreset_i                    =  rx_data_vio_async_out_i[28];
    assign  gtx0_ila_in_i[84]                    =  gtx0_rxchariscomma_i;
    assign  gtx0_ila_in_i[83]                    =  gtx0_rxcharisk_i;
    assign  gtx0_ila_in_i[82]                    =  gtx0_rxdisperr_i;
    assign  gtx0_ila_in_i[81]                    =  gtx0_rxnotintable_i;
    assign  gtx0_ila_in_i[80]                    =  gtx0_rxrundisp_i;
    assign  gtx0_ila_in_i[79:77]                 =  gtx0_rxclkcorcnt_i;
    assign  gtx0_ila_in_i[76:69]                 =  gtx0_rxdata_i;
    assign  gtx0_ila_in_i[68:66]                 =  gtx0_rxbufstatus_i;
    assign  gtx0_ila_in_i[65:58]                 =  gtx0_error_count_i;
    assign  gtx0_ila_in_i[57:0]                  =  58'b0000000000000000000000000000000000000000000000000000000000;



    assign  tx_data_vio_async_in_i =                       gtx0_tx_data_vio_async_in_i;


    assign  tx_data_vio_sync_in_i =                        gtx0_tx_data_vio_sync_in_i;

    assign  rx_data_vio_async_in_i =                       gtx0_rx_data_vio_async_in_i;


    assign  rx_data_vio_sync_in_i =                        gtx0_rx_data_vio_sync_in_i;


    assign  ila_in_i =                                     gtx0_ila_in_i;

end //end EXAMPLE_USE_CHIPSCOPE=1 generate section
else 
begin: no_chipscope

    // If Chipscope is not being used, drive GTX reset signal
    // from the top level ports
    assign  gtx0_gtxrxreset_i = GTXRXRESET_IN;

    // assign resets for frame_gen modules

    // assign resets for frame_check modules
    assign  gtx0_rx_system_reset_c = !gtx0_rxresetdone_r3;

    assign  gtxrxreset_i                         =  tied_to_ground_i;
    assign  user_tx_reset_i                      =  tied_to_ground_i;
    assign  user_rx_reset_i                      =  tied_to_ground_i;
    assign  gtx0_pllrxreset_i                    =  tied_to_ground_i;
    assign  gtx0_rxpowerdown_i                   =  tied_to_ground_vec_i[1:0];
    assign  gtx0_rxbufreset_i                    =  tied_to_ground_i;


end
endgenerate //End generate for EXAMPLE_USE_CHIPSCOPE


endmodule

//-------------------------------------------------------------------
//
//  VIO core module declaration
//
//-------------------------------------------------------------------
module data_vio
  (
    control,
    clk,
    async_in,
    async_out,
    sync_in,
    sync_out
  );
  inout  [35:0] control;
  input         clk;
  input  [31:0] async_in;
  output [31:0] async_out;
  input  [31:0] sync_in;
  output [31:0] sync_out;
endmodule


//-------------------------------------------------------------------
//
//  ICON core module declaration
//
//-------------------------------------------------------------------
module icon
  (
      control0,
      control1,
      control2,
      control3
  );
  inout [35:0] control0;
  inout [35:0] control1;
  inout [35:0] control2;
  inout [35:0] control3;
endmodule


//-------------------------------------------------------------------
//
//  ILA core module declaration
//  This is used to allow RX signals to be monitored
//
//-------------------------------------------------------------------
module ila
  (
    control,
    clk,
    trig0
  );
  inout [35:0] control;
  input clk;
  input [84:0] trig0;
endmodule

