------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 1.8
--  \   \         Application : Virtex-6 FPGA GTX Transceiver Wizard
--  /   /         Filename : daq_gtx_dual_rate.vhd
-- /___/   /\     Timestamp : 
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx Virtex-6 FPGA GTX Transceiver Wizard


--**************************Component Declarations*****************************


component DAQ_GTX_DUAL_RATE 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTXRESET_SPEEDUP    : integer   := 0 -- Set to 1 to speed up sim reset
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GTX0  (X0_Y12)

    ------------------- Receive Ports - RX Data Path interface -----------------
    GTX0_RXRESET_IN                         : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GTX0_RXN_IN                             : in   std_logic;
    GTX0_RXP_IN                             : in   std_logic;
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GTX0_GREFCLKRX_IN                       : in   std_logic;
    GTX0_NORTHREFCLKRX_IN                   : in   std_logic_vector(1 downto 0);
    GTX0_PERFCLKRX_IN                       : in   std_logic;
    GTX0_RXPLLREFSELDY_IN                   : in   std_logic_vector(2 downto 0);
    GTX0_SOUTHREFCLKRX_IN                   : in   std_logic_vector(1 downto 0);
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    GTX0_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------------------- Transmit Ports - GTX Ports -----------------------
    GTX0_GTXTEST_IN                         : in   std_logic_vector(12 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GTX0_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    GTX0_TXOUTCLK_OUT                       : out  std_logic;
    GTX0_TXRESET_IN                         : in   std_logic;
    GTX0_TXUSRCLK2_IN                       : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GTX0_TXN_OUT                            : out  std_logic;
    GTX0_TXP_OUT                            : out  std_logic;
    ----------- Transmit Ports - TX Elastic Buffer and Phase Alignment ---------
    GTX0_TXBUFSTATUS_OUT                    : out  std_logic_vector(1 downto 0);
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GTX0_GREFCLKTX_IN                       : in   std_logic;
    GTX0_GTXTXRESET_IN                      : in   std_logic;
    GTX0_MGTREFCLKTX_IN                     : in   std_logic;
    GTX0_NORTHREFCLKTX_IN                   : in   std_logic_vector(1 downto 0);
    GTX0_PERFCLKTX_IN                       : in   std_logic;
    GTX0_PLLTXRESET_IN                      : in   std_logic;
    GTX0_SOUTHREFCLKTX_IN                   : in   std_logic_vector(1 downto 0);
    GTX0_TXPLLLKDET_OUT                     : out  std_logic;
    GTX0_TXPLLREFSELDY_IN                   : in   std_logic_vector(2 downto 0);
    GTX0_TXRATE_IN                          : in   std_logic_vector(1 downto 0);
    GTX0_TXRATEDONE_OUT                     : out  std_logic;
    GTX0_TXRESETDONE_OUT                    : out  std_logic


);
end component;










    ----------------------------- The GTX Wrapper -----------------------------


    daq_gtx_dual_rate_i : DAQ_GTX_DUAL_RATE
    generic map
    (
        WRAPPER_SIM_GTXRESET_SPEEDUP    =>      1
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GTX0  (X0Y12)

        ------------------- Receive Ports - RX Data Path interface -----------------
        GTX0_RXRESET_IN                 =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTX0_RXN_IN                     =>      ,
        GTX0_RXP_IN                     =>      ,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        GTX0_GREFCLKRX_IN               =>      ,
        GTX0_NORTHREFCLKRX_IN           =>      ,
        GTX0_PERFCLKRX_IN               =>      ,
        GTX0_RXPLLREFSELDY_IN           =>      ,
        GTX0_SOUTHREFCLKRX_IN           =>      ,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        GTX0_TXCHARISK_IN               =>      ,
        ------------------------- Transmit Ports - GTX Ports -----------------------
        GTX0_GTXTEST_IN                 =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GTX0_TXDATA_IN                  =>      ,
        GTX0_TXOUTCLK_OUT               =>      ,
        GTX0_TXRESET_IN                 =>      ,
        GTX0_TXUSRCLK2_IN               =>      ,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTX0_TXN_OUT                    =>      ,
        GTX0_TXP_OUT                    =>      ,
        ----------- Transmit Ports - TX Elastic Buffer and Phase Alignment ---------
        GTX0_TXBUFSTATUS_OUT            =>      ,
        ----------------------- Transmit Ports - TX PLL Ports ----------------------
        GTX0_GREFCLKTX_IN               =>      ,
        GTX0_GTXTXRESET_IN              =>      ,
        GTX0_MGTREFCLKTX_IN             =>      ,
        GTX0_NORTHREFCLKTX_IN           =>      ,
        GTX0_PERFCLKTX_IN               =>      ,
        GTX0_PLLTXRESET_IN              =>      ,
        GTX0_SOUTHREFCLKTX_IN           =>      ,
        GTX0_TXPLLLKDET_OUT             =>      ,
        GTX0_TXPLLREFSELDY_IN           =>      ,
        GTX0_TXRATE_IN                  =>      ,
        GTX0_TXRATEDONE_OUT             =>      ,
        GTX0_TXRESETDONE_OUT            =>      


    );



    -----------------------Dedicated GTX Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS_GTXE1 instance
    
    q3_clk0_refclk_ibufds_i : IBUFDS_GTXE1
    port map
    (
        O                               =>      ,
        ODIV2                           =>      ,
        CEB                             =>      ,
        I                               =>      ,  -- Connect to package pin P6
        IB                              =>        -- Connect to package pin P5
    );












