------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 1.8
--  \   \         Application : Virtex-6 FPGA GTX Transceiver Wizard
--  /   /         Filename : min_latency_test.vhd
-- /___/   /\     Timestamp : 
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx Virtex-6 FPGA GTX Transceiver Wizard


--**************************Component Declarations*****************************


component MIN_LATENCY_TEST 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTXRESET_SPEEDUP    : integer   := 0 -- Set to 1 to speed up sim reset
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GTX0  (X0_Y13)

    ------------------------ Loopback and Powerdown Ports ----------------------
    GTX0_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - RX Data Path interface -----------------
    GTX0_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    GTX0_RXRECCLK_OUT                       : out  std_logic;
    GTX0_RXUSRCLK2_IN                       : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GTX0_RXN_IN                             : in   std_logic;
    GTX0_RXP_IN                             : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    GTX0_RXDLYALIGNDISABLE_IN               : in   std_logic;
    GTX0_RXDLYALIGNMONENB_IN                : in   std_logic;
    GTX0_RXDLYALIGNMONITOR_OUT              : out  std_logic_vector(7 downto 0);
    GTX0_RXDLYALIGNOVERRIDE_IN              : in   std_logic;
    GTX0_RXDLYALIGNRESET_IN                 : in   std_logic;
    GTX0_RXENPMAPHASEALIGN_IN               : in   std_logic;
    GTX0_RXPMASETPHASE_IN                   : in   std_logic;
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GTX0_GTXRXRESET_IN                      : in   std_logic;
    GTX0_MGTREFCLKRX_IN                     : in   std_logic;
    GTX0_PLLRXRESET_IN                      : in   std_logic;
    GTX0_RXPLLLKDET_OUT                     : out  std_logic;
    GTX0_RXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GTX0_TXDATA_IN                          : in   std_logic_vector(31 downto 0);
    GTX0_TXOUTCLK_OUT                       : out  std_logic;
    GTX0_TXUSRCLK_IN                        : in   std_logic;
    GTX0_TXUSRCLK2_IN                       : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GTX0_TXN_OUT                            : out  std_logic;
    GTX0_TXP_OUT                            : out  std_logic;
    -------- Transmit Ports - TX Elastic Buffer and Phase Alignment Ports ------
    GTX0_TXDLYALIGNDISABLE_IN               : in   std_logic;
    GTX0_TXDLYALIGNMONENB_IN                : in   std_logic;
    GTX0_TXDLYALIGNMONITOR_OUT              : out  std_logic_vector(7 downto 0);
    GTX0_TXDLYALIGNRESET_IN                 : in   std_logic;
    GTX0_TXENPMAPHASEALIGN_IN               : in   std_logic;
    GTX0_TXPMASETPHASE_IN                   : in   std_logic;
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GTX0_GTXTXRESET_IN                      : in   std_logic;
    GTX0_MGTREFCLKTX_IN                     : in   std_logic;
    GTX0_PLLTXRESET_IN                      : in   std_logic;
    GTX0_TXPLLLKDET_OUT                     : out  std_logic;
    GTX0_TXRESETDONE_OUT                    : out  std_logic


);
end component;



component TX_SYNC 
port
(
    TXENPMAPHASEALIGN       : out std_logic;
    TXPMASETPHASE           : out std_logic;
    TXDLYALIGNDISABLE       : out std_logic;
    TXDLYALIGNRESET         : out std_logic;
    SYNC_DONE               : out std_logic;
    USER_CLK                : in  std_logic;
    RESET                   : in  std_logic
);
end component;

component RX_SYNC 
port
(
    RXENPMAPHASEALIGN       : out std_logic;
    RXPMASETPHASE           : out std_logic;
    RXDLYALIGNDISABLE       : out std_logic;
    RXDLYALIGNRESET         : out std_logic;
    SYNC_DONE               : out std_logic;
    USER_CLK                : in  std_logic;
    RESET                   : in  std_logic
);
end component;






    ----------------------------- The GTX Wrapper -----------------------------


    min_latency_test_i : MIN_LATENCY_TEST
    generic map
    (
        WRAPPER_SIM_GTXRESET_SPEEDUP    =>      1
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GTX0  (X0Y13)

        ------------------------ Loopback and Powerdown Ports ----------------------
        GTX0_LOOPBACK_IN                =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        GTX0_RXDATA_OUT                 =>      ,
        GTX0_RXRECCLK_OUT               =>      ,
        GTX0_RXUSRCLK2_IN               =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTX0_RXN_IN                     =>      ,
        GTX0_RXP_IN                     =>      ,
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        GTX0_RXDLYALIGNDISABLE_IN       =>      ,
        GTX0_RXDLYALIGNMONENB_IN        =>      ,
        GTX0_RXDLYALIGNMONITOR_OUT      =>      ,
        GTX0_RXDLYALIGNOVERRIDE_IN      =>      ,
        GTX0_RXDLYALIGNRESET_IN         =>      ,
        GTX0_RXENPMAPHASEALIGN_IN       =>      ,
        GTX0_RXPMASETPHASE_IN           =>      ,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        GTX0_GTXRXRESET_IN              =>      ,
        GTX0_MGTREFCLKRX_IN             =>      ,
        GTX0_PLLRXRESET_IN              =>      ,
        GTX0_RXPLLLKDET_OUT             =>      ,
        GTX0_RXRESETDONE_OUT            =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GTX0_TXDATA_IN                  =>      ,
        GTX0_TXOUTCLK_OUT               =>      ,
        GTX0_TXUSRCLK_IN                =>      ,
        GTX0_TXUSRCLK2_IN               =>      ,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTX0_TXN_OUT                    =>      ,
        GTX0_TXP_OUT                    =>      ,
        -------- Transmit Ports - TX Elastic Buffer and Phase Alignment Ports ------
        GTX0_TXDLYALIGNDISABLE_IN       =>      ,
        GTX0_TXDLYALIGNMONENB_IN        =>      ,
        GTX0_TXDLYALIGNMONITOR_OUT      =>      ,
        GTX0_TXDLYALIGNRESET_IN         =>      ,
        GTX0_TXENPMAPHASEALIGN_IN       =>      ,
        GTX0_TXPMASETPHASE_IN           =>      ,
        ----------------------- Transmit Ports - TX PLL Ports ----------------------
        GTX0_GTXTXRESET_IN              =>      ,
        GTX0_MGTREFCLKTX_IN             =>      ,
        GTX0_PLLTXRESET_IN              =>      ,
        GTX0_TXPLLLKDET_OUT             =>      ,
        GTX0_TXRESETDONE_OUT            =>      


    );



    -----------------------Dedicated GTX Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS_GTXE1 instance
    
    q3_clk1_refclk_ibufds_i : IBUFDS_GTXE1
    port map
    (
        O                               =>      ,
        ODIV2                           =>      ,
        CEB                             =>      ,
        I                               =>      ,  -- Connect to package pin M6
        IB                              =>        -- Connect to package pin M5
    );





    ------------------------------ TXSYNC module ------------------------------
    -- Since you are bypassing the TX Buffer in your wrapper, you will need to drive
    -- the phase alignment ports to align the phase of the TX Datapath. Include
    -- this module in your design to have phase alignment performed automatically as
    -- it is done in the example design.

    
    gtx0_txsync_i : TX_SYNC
    port map
    (
        TXENPMAPHASEALIGN               =>            
        TXPMASETPHASE                   =>      
        TXDLYALIGNDISABLE               =>      
        TXDLYALIGNRESET                 =>      
        SYNC_DONE                       =>      
        USER_CLK                        =>      
        RESET                           =>      ,
    );


    ---------------------------- RXSYNC modules -------------------------------
    -- The RXSYNC module performs phase synchronization for all the active RX datapaths. It
    -- waits for the user clocks to be stable, then drives the RX phase align signals on each
    -- GTX. When phase synchronization is complete, it asserts SYNC_DONE
    
    -- Include one RX_SYNC module per Buffer bypassed RX datapath in your own design. RX_SYNC modules
    -- can also be shared, but when sharing, make sure to hold the module in reset until all lanes have 
    -- a stable clock
    
  
    
    gtx0_rxsync_i : RX_SYNC
    port map
    (
        RXENPMAPHASEALIGN               =>          
        RXPMASETPHASE                   =>      
        RXDLYALIGNDISABLE               =>      
        RXDLYALIGNRESET                 =>      
        SYNC_DONE                       =>      
        USER_CLK                        =>      
        RESET                           =>      ,
    );
    






